package BowlingGame;

class Game {
    private int score = 0;
    private int rolls[] = new int[21];
    private int currentRoll = 0;

    /*
    void roll(int pins) {
        score += pins;
        // wrong design: not the score calculates!!!
    }

    int score() {
        // return -1; // 4.
        // return 0;
        return score;
    }
    */

    void roll(int pins) {
        rolls[currentRoll++] = pins;
    }

    int score() {
        int score = 0; /*
        for (int i = 0; i <rolls.length; i++){
            score += rolls[i];
        } */
        int firstInFrame = 0;
        for (int frame = 0; frame < 10; frame++){
            // put this condition into method
            if (isSpare(firstInFrame)){
                score += 10 + nextTwoBallForSpare(firstInFrame);
                firstInFrame += 2;
            } else if (isStrike(firstInFrame)){
                score += 10 + nextTwoBallsForStrike(firstInFrame);
                firstInFrame++;
            } else {
                score += twoBallsInFrame(firstInFrame);
                firstInFrame += 2;
            }
        }
        return score;
    }
    
    public boolean isSpare(int firstInFrame){
        return rolls[firstInFrame] + rolls[firstInFrame+1] == 10;
    }

    public boolean isStrike(int firstInFrame){
        return rolls[firstInFrame] == 10;
    }
    
    public int nextTwoBallsForStrike(int firstInFrame){
        return rolls[firstInFrame+1] + rolls[firstInFrame+2];
    }
    
    public int nextTwoBallForSpare(int firstInFrame){
        return rolls[firstInFrame+2];
    }
    
    public int twoBallsInFrame(int firstInFrame){
        return rolls[firstInFrame] + rolls[firstInFrame+1];
    }

}
